# -*- coding: utf-8 -*-

"""
multiauthsample

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from apimatic_core.authentication.header_auth import HeaderAuth


class OAuthBearerToken(HeaderAuth):

    @property
    def error_message(self):
        """Display error message on occurrence of authentication failure
        in OAuthBearerToken

        """
        return "OAuthBearerToken: AccessToken is undefined."

    def __init__(self, o_auth_bearer_token_credentials):
        auth_params = {}
        self._access_token = o_auth_bearer_token_credentials.access_token \
            if o_auth_bearer_token_credentials is not None else None
        if self._access_token:
            auth_params["Authorization"] = "Bearer {}".format(self._access_token)
        super().__init__(auth_params=auth_params)


class OAuthBearerTokenCredentials:

    @property
    def access_token(self):
        return self._access_token

    def __init__(self, access_token):
        if access_token is None:
            raise ValueError('access_token cannot be None')
        self._access_token = access_token

    def clone_with(self, access_token=None):
        return OAuthBearerTokenCredentials(access_token or self.access_token)
